# 【春 v2】内测预览版使用须知

尊敬的内测用户，感谢您参与本次本光影着色器（shader）的内测！
本版本为练习用的内测（预览）版本，目前光影效果仍在制作完善中。
以下是使用过程中的重要注意事项，请您仔细阅读并遵守：

## 一、使用限制
1. 本 shader 仅在指定群聊内发布，属于内部测试版本，请勿将 shader 文件外传至群外。
2. 未经本人（ZY - PANDA（中影））明确书面许可，禁止以任何形式挪用、修改、分发本 shader 中的代码。

## 二、参考内容
1. 本光影是本人在学习《Games202 - 高质量实时渲染》课程时编写的练习作品，课程链接为：
    - [https://sites.cs.ucsb.edu/~lingqi/teaching/games202.html](https://sites.cs.ucsb.edu/~lingqi/teaching/games202.html)
2. 光影思路、代码等参考内容均已在具体代码中详细注释。同时也参考了以下资料：
    - [https://learnopengl-cn.github.io](https://learnopengl-cn.github.io)
    - [https://optifine.readthedocs.io/shaders_dev.html](https://optifine.readthedocs.io/shaders_dev.html)
    - [https://pastebin.com/aB5MJ7aN](https://pastebin.com/aB5MJ7aN)
    - [https://cdn.discordapp.com/attachments/237199950235041794/825483993951633438/base.zip](https://cdn.discordapp.com/attachments/237199950235041794/825483993951633438/base.zip)
    - [https://cdn.discordapp.com/attachments/960320448594329630/960695935837548695/base150.zip](https://cdn.discordapp.com/attachments/960320448594329630/960695935837548695/base150.zip)
3. 还主要参考了两位大佬的光影编写教程：
    - [https://blog.csdn.net/weixin_44176696/category_10388318.html](https://blog.csdn.net/weixin_44176696/category_10388318.html)
    - [http://blog.hakugyokurou.net/?p=1364](http://blog.hakugyokurou.net/?p=1364)
4. 部分代码思路主要参考了多个 AI 工具，包括 Claude、Deepseek、ChatGPT、Gemini、Doubao 和 Qwen 等。
5. 文件管理方式参考自 BSL shader。

## 三、反馈建议
1. 若发现代码侵权或代码侵犯您的版权，请通过 QQ 2767334552 与本人联系。
2. 如果您在使用过程中遇到任何问题、有优化建议或发现代码存在异常，请联系我，或在群内反馈，您的反馈将对本 shader 的完善起到重要作用。

再次感谢您的支持与配合！

编写人：ZY - PANDA（中影）
发布日期：2025.01.28




# 【Chun v2】Internal Beta Preview - User Guide

Dear Beta Tester, thank you for participating in the internal beta test of this shader!
This version is a practice-oriented internal beta (preview) version, and the shader effects are still under development and improvement.
The following are important precautions for using this version. Please read and adhere to them carefully:

## I. Usage Restrictions
1.  This shader is only released within the designated group chat and is an internal test version. Please do not distribute the shader files outside the group.
2.  Without the express permission of the author (ZY - PANDA (中影)), it is forbidden to misappropriate, modify, or distribute the code in this shader in any form.

## II. Reference Materials
1.  This shader is a practice project written by the author while studying the "Games202 - High-Quality Real-Time Rendering" course. The course link is:
    -   [https://sites.cs.ucsb.edu/~lingqi/teaching/games202.html](https://sites.cs.ucsb.edu/~lingqi/teaching/games202.html)
2.  The shader ideas, code, and other reference materials are annotated in detail within the code itself. The following resources were also referenced:
    -   [https://learnopengl-cn.github.io](https://learnopengl-cn.github.io)
    -   [https://optifine.readthedocs.io/shaders_dev.html](https://optifine.readthedocs.io/shaders_dev.html)
    -   [https://pastebin.com/aB5MJ7aN](https://pastebin.com/aB5MJ7aN)
    -   [https://cdn.discordapp.com/attachments/237199950235041794/825483993951633438/base.zip](https://cdn.discordapp.com/attachments/237199950235041794/825483993951633438/base.zip)
    -   [https://cdn.discordapp.com/attachments/960320448594329630/960695935837548695/base150.zip](https://cdn.discordapp.com/attachments/960320448594329630/960695935837548695/base150.zip)
3.  Significant reference was also made to the shader writing tutorials of the following two experts:
    -   [https://blog.csdn.net/weixin_44176696/category_10388318.html](https://blog.csdn.net/weixin_44176696/category_10388318.html)
    -   [http://blog.hakugyokurou.net/?p=1364](http://blog.hakugyokurou.net/?p=1364)
4.  Some of the code logic is primarily inspired by AI tools such as Claude, Deepseek, ChatGPT, Gemini, Doubao, and Qwen, among others.
5.  The file management method is referenced from BSL shader.

## III. Feedback and Suggestions
1.  If you find any code infringement or code that infringes upon your copyright, please contact the author via QQ 2767334552.
2.  If you encounter any problems during use, have optimization suggestions, or find any anomalies in the code, please contact the author or provide feedback within the group. Your feedback will play an important role in improving this shader.

Thank you again for your support and cooperation!

Author: ZY - PANDA (中影)
Release Date: 2025.01.28
